# Introduction
The files in this archive will help you when you need to isolate a Meraki network protected by any MX (includes Z3) device from the rest of your network, both for incoming traffic (e.g. from hackers) as well as for outgoing traffic (e.g. prevent your endpoints from infecting others with ransomware or talking to any C&C server).

# Prepare Your Python Environment
You need to install
1. python3 (python2 is not sufficient) on your Linux machine as well as
2. the script "mxfirewallcontrol.py" which includes
3. some further modules (use `pip3 install` and not `pip install`!)

before you can effectively use the scripts provided in this archive.

The scripts are run by `bash` shell, so if you don't have it already installed on your host, you will need to `apk add bash`!

# Run the Scripts
There are 3 `bash` script files included for 3 different tasks plus 2 other help files. You first need to edit the file named `secrets.env` which includes the name of your Meraki organization plus the Restful API key you're gonna use.

## Check for Tag "iso"
The following command should help you to double-check what Meraki networks are currently tagged with the tag named `iso`:

    source isoshow.sh

It will show you a list of relevant sites -- or nothing at all.

## Isolate the Sites with Tag "iso"
Next step is to really isolate all Meraki networks are currently tagged with the tag named `iso`:

    source isolate.sh

The script will create a backup of the former set of firewall rules per site and copy it into a new subdirectory so they can be easily rolled back to if something odd happens.
***You should not run this script a second, third, etc. time after it has been successfully run for a first time, because this would add further redundant firewall rules to the current set of rules for a Meraki network that would need to be removed later manually.***

## Rollback all Isolated Sites to State before
If the disaster condition has been cleared, you can use the following single command to rollback all isolations at once:

    source isorollback.sh

This script will simply delete all rules that have a comment field value of "Site isolated temporarily".
You can run it twice or more, this will not make any difference, because the isolating "deny all firewall rule" has already been deleted when run for the first time.

# Annex

## Deny All Rule
The file `denyallrule-formatted.json` is a beautifully formatted copy of the proper firewall rule that might be easier to read than the one to be effectively used. The underlying python script does ***not*** like its indented syntax, so you should not try to use this copy!

## Further Reading
[Meraki documentation of Python script](https://github.com/meraki/automation-scripts/blob/master/mxfirewallcontrol_manual.pdf)
[Python script itself](https://github.com/meraki/automation-scripts/blob/master/mxfirewallcontrol.py)
[github source root](https://github.com/meraki/automation-scripts)